GlassEyeGUI = {
	["Frames"] = { }
}

function GlassEyeGUI:RegisterWindow(data)
	local tables = GlassEyeGUI["Frames"]
	local toggle = nil
	for key, value in tables do
		if value["FrameID"] == data["FrameID"] then
			toggle = 1
		end
	end
	if not toggle then

		if (not data["Focus"]) then
			data["Focus"] = 0
		end


		table.insert(GlassEyeGUI["Frames"], data);
		return 1
	end
	return nil
end


function GlassEyeGUI:UnregisterWindow(data)
	local tables = GlassEyeGUI["Frames"]
	local result = nil
	for key, value in tables do
		if value["FrameID"] == data then
			result = key
		end
	end
	if result then
		table.remove (tables, key)
	end
end

function GlassEyeGUI:GetHWND(data)
	local tables = GlassEyeGUI["Frames"]
	local result = nil
	for key, value in tables do
		if value["FrameID"] == data then
			result = key
		end
	end
	return result
end

function GlassEyeGUI:UpdateElements(frameid)
	local frame = GlassEyeGUI["Frames"][frameid]
	local Elements = GlassEyeGUI["Frames"][frameid]["Elements"]
	if (Elements) then
		for key,value in Elements do
			if value["Visible"] and value["Type"] then
				if (value["Type"] == "Button") then
					local x = value["X"]+frame["X"]
					local y = value["Y"]+frame["Y"]+22
					local w = value["Width"]
					local h = value["Height"]
					if (value["IsKeyDown"]) then
						GlassEye.screen:fillRect(x, y, w, h, Color.new(255,255,255))
						GlassEye.screen:fillRect(x, y, w-1, h-1, Color.new(64,64,64))
						GlassEye.screen:fillRect(x+1, y+1, w-2, h-2, Color.new(212,208,200))
						GlassEye.screen:fillRect(x+1, y+1, w-3, h-3, Color.new(128,128,128))
						GlassEye.screen:fillRect(x+2, y+2, w-4, h-4, Color.new(212,208,200))
						--screen:print((x+(w/2)) - string.len(value["Text"])/2 * 8 , y+(h/2)-3, value["Text"], Color.new(0, 0, 0))
						GlassEye.screen:fontPrint(TimesNewRoman, (x+(w/2)) - string.len(value["Text"])/2 * 8 , y+(h/2)+7, value["Text"], Color.new(0, 0, 0))
					else
						GlassEye.screen:fillRect(x, y, w, h, Color.new(64,64,64))
						GlassEye.screen:fillRect(x, y, w-1, h-1, Color.new(255,255,255))
						GlassEye.screen:fillRect(x+1, y+1, w-2, h-2, Color.new(128,128,128))
						GlassEye.screen:fillRect(x+1, y+1, w-3, h-3, Color.new(212,208,200))
						--screen:print((x+(w/2)) - string.len(value["Text"])/2 * 8 , y+(h/2)+5, value["Text"], Color.new(0, 0, 0))
						GlassEye.screen:fontPrint(TimesNewRoman, (x+(w/2)) - string.len(value["Text"])/2 * 8 , y+(h/2)+5, value["Text"], Color.new(0, 0, 0))
					end
				end
				if (value["Type"] == "Text") then
					if (value["Text"]) then
						local x = value["X"]+frame["X"]
						local y = value["Y"]+frame["Y"]+22
						local w = value["Width"]
						local h = value["Height"]
						
						if (value["Align"] == "LEFT") then
							x = x
							y = y+(h/2)+5
						elseif (value["Align"] == "CENTER") then
							x = (x+(w/2)) - (string.len(value["Text"])/2 * 8)
							y = y+(h/2)+5
						elseif (value["Align"] == "RIGHT") then
							x = (x+w) - (string.len(value["Text"]) * 8)-7
							y = y+(h/2)+5
						else
							x = x
							y = y+(h/2)+5
						end
						--screen:print(x, y, value["Text"], Color.new(0, 0, 0))
						GlassEye.screen:fontPrint(TimesNewRoman, x, y, value["Text"], Color.new(0, 0, 0))
					end
				end
				if (value["Type"] == "DrawBox") then
					local x = value["X"]+frame["X"]
					local y = value["Y"]+frame["Y"]+22
					local w = value["Width"]
					local h = value["Height"]

					GlassEye.screen:fillRect(x, y, w, h, Color.new(value["BorderColor"][1], value["BorderColor"][2], value["BorderColor"][3]))
					GlassEye.screen:fillRect(x+1, y+1, w-2, h-2, Color.new(value["BGColor"][1], value["BGColor"][2], value["BGColor"][3]))
				end
			else
				value["Visible"] = nil
			end
		end
	end
end


function GlassEyeGUI:UpdateWindows()
	local tables = GlassEyeGUI["Frames"]
	
	for key,value in tables do

		if value["Visible"] then
			local x = value["X"]
			local y = value["Y"]
			local w = value["Width"]
			local h = value["Height"]
			GlassEye.screen:fillRect(x, y, w, h, Color.new(64,64,64))
			GlassEye.screen:fillRect(x, y, w-1, h-1, Color.new(212,208,200))
			GlassEye.screen:fillRect(x+1, y+1, w-2, h-2, Color.new(128,128,128))
			GlassEye.screen:fillRect(x+1, y+1, w-3, h-3, Color.new(255,255,255))
			GlassEye.screen:fillRect(x+2, y+2, w-4, h-4, Color.new(212,208,200))

			local showbar = 1
			-- Add Bar
			if (value["Toolbar"]) then
				if (value["Toolbar"] == "hide") then
					showbar = nil
				end
			end

			if (value["Focus"] == 1) and (showbar) then
				GlassEye.screen:fillRect(x+3, y+3, w-6, 18, Color.new(12,38,108))
				GlassEye.screen:print((x+(w/2)) - string.len(value["Text"])/2 * 7.5 , y+8, value["Text"], Color.new(255, 255, 255))
			elseif (showbar) then
				GlassEye.screen:fillRect(x+3, y+3, w-6, 18, Color.new(64,64,64))
				GlassEye.screen:print((x+(w/2)) - string.len(value["Text"])/2 * 7.5 , y+8, value["Text"], Color.new(0, 0, 0))
			end
			GlassEyeGUI:UpdateElements(key)
		end
	end
end


function GlassEyeGUI:WindowClicks()
	local frames = GlassEyeGUI["Frames"]
	local Focus = nil

	table.sort(
		frames,
		function(v1, v2)
			return v1["Focus"] > v2["Focus"];
		end
	)
	for key,value in frames do
		if value["Visible"] then
			value["Focus"] = 0;
			if (GlassEye.CurX > value["X"]) and (GlassEye.CurX < value["X"]+value["Width"]) and (GlassEye.CurY > value["Y"]) and (GlassEye.CurY < value["Y"]+value["Height"]) then
				if (not Focus) then
					value["Focus"] = 1
					Focus = 1
					if (value["FormOnClick"]) then
						value["FormOnClick"](key)
					end
					GlassEyeGUI:CheckElements(key)
				end
			end
		end
	end
	table.sort(
		frames, 
		function(v1, v2)
			return v1["Focus"] < v2["Focus"];
		end
	);
end

function GlassEyeGUI:CheckElements(frameid)
	local frame = GlassEyeGUI["Frames"][frameid]
	local Elements = GlassEyeGUI["Frames"][frameid]["Elements"]
	for key,value in Elements do
		if (GlassEyeInput:KeyUp("Cross")) then
			value["IsKeyDown"] = nil
		end
		local xoffset = frame["X"]+value["X"]
		local yoffset = frame["Y"]+value["Y"]+22
		if (GlassEye.CurX > xoffset) and (GlassEye.CurX < xoffset+value["Width"]) and  (GlassEye.CurY > yoffset) and (GlassEye.CurY < yoffset+value["Height"]) then
			if (value["Visible"]) then
				if (GlassEyeInput:KeyUp("Cross")) then
					if (value["OnKeyUp"]) then
						value["OnKeyUp"](frameid, key)
					end
				end
				if (GlassEyeInput:KeyDown("Cross")) then
					value["IsKeyDown"] = 1
					if (value["OnKeyDown"]) then
						value["OnKeyDown"](frameid, key)
					end
				end
			end
		end
	end
end